
var datepickerVar = {
    ticker: null,
    languageLoaded: false,
    windowHandle: null,

    checkLanguageLoaded: function() {
        if (!this.languageLoaded) {
            this.languageLoaded = true;
            datepickerLanguageVar.loadLanguage();
        }
    },

    setPanelPosition: function() {
        try {
            var position = datepickerPrefUtilsVar.getCharacterPreferenceValueWithDefault("position", Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch), "");
            var myRegExp = new RegExp(" ", "");
            if (myRegExp.test(position) && (RegExp.rightContext != "")) {
                var statusbar = document.getElementById("status-bar");
                var myPanel = document.getElementById("statusbar-datepicker-display");
                var panels = statusbar.getElementsByAttribute("id", RegExp.rightContext);
                if (panels.length > 0) {
                    if (RegExp.leftContext == "before") {
                        statusbar.removeChild(myPanel);
                        statusbar.insertBefore(myPanel, panels[0]);
                    } else if (RegExp.leftContext == "after") {
                        statusbar.removeChild(myPanel);
                        statusbar.insertBefore(myPanel, panels[0].nextSibling);
                    }
                }
            }
        } catch(ex) { dump(ex + "\n"); }
    },

    init: function() {
        this.setPanelPosition();
        this.setDefaultPreferences();
        this.refreshDate();
    },

    setDefaultPreferences: function() {
        this.checkLanguageLoaded();
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        prefs.setCharPref("datepicker.dateFormat", datepickerPrefUtilsVar.getCharacterPreferenceValueWithDefault("dateFormat", prefs, datepickerLanguageVar.dateFormat));
        prefs.setCharPref("datepicker.shortDateFormat", datepickerPrefUtilsVar.getCharacterPreferenceValueWithDefault("shortDateFormat", prefs, datepickerLanguageVar.shortDateFormat));
        prefs.setIntPref("datepicker.weekStart", datepickerPrefUtilsVar.getIntegerPreferenceValue("weekStart", prefs, datepickerLanguageVar.weekStart));
    },

    removeTicker: function() {
        try { window.clearInterval(this.ticker); } catch(ex) {}
    },

    refreshDate: function() {
        this.removeTicker();
        this.checkLanguageLoaded();
        this.updateDate();
        this.ticker = window.setInterval(RefreshdatepickerFunction, datepickerVar.getInterval());
    },

    getInterval: function() {
        var sdf = datepickerVar.getShortDateFormat()
        if (sdf.indexOf('%s') > -1 || sdf.indexOf('%S') > -1) {
            return 200;
        } else if (sdf.indexOf('%M') > -1) {
            return 10000;
        } else {
            return 50000;
        }
    },

    updateDate: function() {
        document.getElementById("statusbar-datepicker-display").setAttribute("label", new Date().datepickerPrint(datepickerVar.getShortDateFormat()));
    },

    getShortDateFormat: function() {
        return datepickerPrefUtilsVar.getCharacterPreferenceValueWithDefault("shortDateFormat", Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch), "%d %b");
    },

    showCalendar: function(event) {
        if (event.button == 0) {
            if (datepickerVar.windowHandle == null || datepickerVar.windowHandle.closed) {
                datepickerVar.windowHandle = window.openDialog(
                    "chrome://datepicker/content/showCal.xul",
                    "_datepicker",
                    "chrome,centerscreen,resizable=no");
            } else {
                datepickerVar.windowHandle.focus();
            }
        }
    },

    showOptions: function() {
        window.openDialog(
                "chrome://datepicker/content/datepickerPrefs.xul",
                "_datepickerOptions",
	 	        "chrome,toolbar,modal,centerscreen,resizable=no,dependent=yes");
    }
}

window.addEventListener("load", function() {datepickerVar.init();}, false);
window.addEventListener("focus", function() {datepickerVar.refreshDate();}, false);
window.addEventListener("unload", function() { datepickerVar.removeTicker(); }, false);

function RefreshdatepickerFunction() {
	datepickerVar.updateDate();
}

